import { Injectable } from '@nestjs/common';
import { BaseUpdateManager } from 'src/core/modules/domain/usecase/managers/base-update.manager';
import { TermConditionEntity } from '../../entities/term-condition.entity';
import { TermConditionModel } from '../../../data/models/term-condition.model';
import { TermConditionUpdatedEvent } from '../../entities/event/term-condition-updated.event';
import {
  EventTopics,
  columnUniques,
  validateRelations,
} from 'src/core/strings/constants/interface.constants';

@Injectable()
export class UpdateTermConditionManager extends BaseUpdateManager<TermConditionEntity> {
  async validateProcess(): Promise<void> {
    return;
  }

  async beforeProcess(): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get uniqueColumns(): columnUniques[] {
    return [];
  }

  get entityTarget(): any {
    return TermConditionModel;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: TermConditionUpdatedEvent,
      },
    ];
  }
}
